procedure stage3;
{Finds the trajectory of TSTO payload.
 Steven S. Pietrobon 25 Dec 1997. Revised 30 Mar 1999, 14 Jan 2000}
var vo,m_f,m_p,m_e,m_c:double;
    ans:char;

begin{stage 3}
  write(question,'Transfer to apogee? ');
  readln(ans);

  if (ans = 'y') or (ans = 'Y') then
    begin{to orbit}
      f0 := 0.0;
      Fd := 0.0;
      Ar := pi*sqr(ET_D)/4;
      m1 := 0.0;
      Me := 0.0;
      p0 := 0.0;
      dt := 1.0;
      dp := 0.0;
      dF := 0.0;
      dRp := 0.0;
      traj := air;
      fair := false;
      repeat
        trajectory;
      until 1.0004*h0 > ha;
      write('Perigee = ',(hp/1000):5:1,' km, ');
      write('Apogee = ',(ha/1000):5:1,' km, ');
      writeln('Average Altitude = ',(hp+ha)/2000:5:1,' km');

      write(question,'Orbit Burn? ');
      readln(ans);
      if (ans = 'y') or (ans = 'Y') then
        begin{Orbit}
          writeln('Orbit burn!');
          mi := m0;
          traj := vac;
          f0 := US_Fv*MPS_R3;
          m1 := -f0/US_Vv;
          vo := sqrt(mu/(Re+h0));
          dt := 1.0;
          repeat
            trajectory
          until vi > vo;
          dt := -1.0;
          trajectory;
          dt := -((m0+Me)/(1/(exp((sqrt(mu/(Re+h0))-vi)/US_Vv)-1)+1))/m1;
          trajectory;
          if hp > 0
            then writeln('You have successfully reached low Earth orbit!')
            else writeln('Are you sure you know how to fly this thing?');
          write('Perigee = ',(hp/1000):5:1,' km, ');
          write('Apogee = ',(ha/1000):5:1,' km, ');
          writeln('Average Altitude = ',(hp+ha)/2000:5:1,' km');
          m_f := m0*exp(-TMI_V/US_Vv);
          m_p := mi-m_f;
          m_e := CA*exp(CB*ln((m_p/1000)));
          m_c := m_f-m_e;
          write('m_p = ',round(m_p):1,' kg, m_e = ',round(m_e):1,' kg, ');
          writeln('m_c = ',round(m_c):1,' kg, m_f = ',round(m_p+m_f):1,' kg.');
          write(question,'Continue? ');
          readln(continue);
        end;{Orbit}
    end;{to orbit}
end;{stage 3}
